#ifndef __GM_MCP_USERLIST_VIEW_H__
#define __GM_MCP_USERLIST_VIEW_H__

 
typedef enum _PlayerStateMask {
	USERLIST_STATE_IDLE = 1 << 0,
	USERLIST_STATE_BUSY = 1 << 1,
	USERLIST_STATE_AWAY = 1 << 2
} PlayerStateMask;

typedef enum _UserlistEvent {
	USERLIST_EVENT_NONE = 0,
	USERLIST_EVENT_ONLINE = 1 << 0,
	USERLIST_EVENT_OFFLINE = 1 << 1,
	USERLIST_EVENT_IDLE_ON = 1 << 2,
	USERLIST_EVENT_IDLE_OFF = 1 << 3,
	USERLIST_EVENT_AWAY_ON = 1 << 4,
	USERLIST_EVENT_AWAY_OFF = 1 << 5
} UserlistEvent;

typedef enum _GmUserlistSortType {
	GM_USERLIST_SORT_TYPE_STATE_RANK_NAME,
	GM_USERLIST_SORT_TYPE_RANK_NAME,
	GM_USERLIST_SORT_TYPE_STATE_NAME,
	GM_USERLIST_SORT_TYPE_NAME,
	GM_USERLIST_SORT_TYPE_NUM
} GmUserlistSortType;

enum {
	GM_USERLIST_ICON,
	GM_USERLIST_NAME,
	GM_USERLIST_STATUS,
	GM_USERLIST_ID,
	GM_USERLIST_RANK_PRIORITY,
	GM_USERLIST_STATE_PRIORITY,
	GM_USERLIST_N_COLUMNS
};

void gm_mcp_userlist_view_new(GmMcpPackage *package, GObject *parent);


#endif /* __GM_MCP_USERLIST_VIEW_H__ */
